"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@collectable/core");
const internals_1 = require("../internals");
const internals_2 = require("../internals");
function map(fn, map) {
    var immutable = core_1.isImmutable(map._owner);
    var nextMap = internals_1.cloneSortedMap(true, map, true);
    var { _keyMap: keyMap, _sortedValues: sortedValues, _select: select } = nextMap;
    var it = internals_2.iterate(map);
    var current;
    var index = 0;
    while (!(current = it.next()).done) {
        var value = current.value;
        internals_2.setItem(value.key, fn(value.value, value.key, index++), keyMap, sortedValues, select);
    }
    if (immutable) {
        return internals_1.refreeze(nextMap);
    }
    map._keyMap = keyMap;
    map._sortedValues = sortedValues;
    return map;
}
exports.map = map;
;

//# sourceMappingURL=map.js.map
