import { isImmutable } from '@collectable/core';
import { refreeze, cloneSortedMap } from '../internals';
import { iterate, setItem } from '../internals';
export function map(fn, map) {
    var immutable = isImmutable(map._owner);
    var nextMap = cloneSortedMap(true, map, true);
    var { _keyMap: keyMap, _sortedValues: sortedValues, _select: select } = nextMap;
    var it = iterate(map);
    var current;
    var index = 0;
    while (!(current = it.next()).done) {
        var value = current.value;
        setItem(value.key, fn(value.value, value.key, index++), keyMap, sortedValues, select);
    }
    if (immutable) {
        return refreeze(nextMap);
    }
    map._keyMap = keyMap;
    map._sortedValues = sortedValues;
    return map;
}
;

//# sourceMappingURL=map.js.map
