import { curry3 } from '@typed/curry';
import { keys } from '@collectable/red-black-tree';
import { preventCircularRefs, unwrapAny } from '@collectable/core';
import { iteratePairs } from '../internals';
const newObject = (map) => ({});
const unwrapShallow = curry3(unwrapMap)(false);
const unwrapDeep = curry3(preventCircularRefs)(newObject, curry3(unwrapMap)(true));
export function toArray(map) {
    return Array.from(map);
}
export function toNativeMap(map) {
    return new Map(iteratePairs(map));
}
export function unwrap(deep, map) {
    return deep ? unwrapDeep(map) : unwrapShallow(map, newObject(map));
}
function unwrapMap(deep, map, target) {
    var it = keys(map._sortedValues);
    var current;
    while (!(current = it.next()).done) {
        var entry = current.value;
        target[entry.key] = deep ? unwrapAny(entry.value) : entry.value;
    }
    return target;
}

//# sourceMappingURL=unwrap.js.map
